#include <stdio.h>
#include <stdlib.h>

#define MAXSIZE 10000


/* Inverte l'array A in loco */
void inverti( int A[], int n )
{
     int i, j, scambio; 

     for ( i = 0; i <= n/2; i++ ) 
     {    
	 j = (n-1)-i;

         scambio = A [i];
	 A[i] = A[j];
/* errore per i test:	 A[j] = A[scambio]; */
	 A[j] = scambio;
     }
}

void stampa( int output[], int n)
{
     int i;

     for ( i = 0; i < n; i++ ) 
       printf("%d ", output[i]);
     printf("\n");
}

void prepara(int A[], int n)
{
    int i;
    for ( i = 0; i < n ; i++ ) 
	A[i] = i;
}

void permuta(int A[], int n, int seme)
{
    int i, j, scambio;

    srand(seme); 
    for ( i = 0; i < n-1; i++ )
    {
       j = i + ( rand() % ( n-i ) ) ;

       scambio = A[i];
       A[i] = A[j];
       A[j] = scambio;
    }
}

void copia ( int sorgente[], int destinazione[], int n)
{
    int i;
    for ( i = 0; i < n; i++ ) 
	destinazione[i] = sorgente[i];
}

void controlla( int A[], int B[], int n)
{
    int i;
    for ( i = 0; i < n; i++ ) 
	if ( A[i] != B[i] ) 
	{
		printf("Errore alla posizione %d\n", i);
		return;
 	}
    printf("OK!\n"); 
}


int main()
{
   int n, seme;
   int A[MAXSIZE], B[MAXSIZE];

   scanf("%d %d", &seme, &n);

   prepara( A, n );
   permuta( A, n, seme);
   copia( A, B, n ); 
   inverti(B, n);
   inverti(B, n);
   controlla (A, B, n);

   return 0;
}
