/** Esercizi 24/2/2009
    
    Ricerca l'elemento mancante nella sequenza
    utilizzando la forza bruta: per i = 0, n,
    cerca la sua presenza nell'array immesso.
*/
#include <stdio.h>
#include <stdlib.h>

#define MAXSIZE 10000

int leggi( int input[] ) 
{
     int n, i;

     scanf("%d", &n );
     if ( n < 1 || n > MAXSIZE ) 
     {
	printf("Errore: l'array deve avere dimensione tra 1 e %d\n", 
		MAXSIZE );
	exit(1);
     }

     for ( i = 0; i < n; i++ )
	scanf("%d", &input[i]);

     return n;
}

int manca ( int A[], int n, int valore )
{
    int i, mancante = 1;
    i = 0;
    while ( mancante && i < n )
    {
	if( A[i] == valore ) 
	   mancante = 0;
	i++;
    }

    return mancante;
}


int main()
{
    int A[MAXSIZE] ;
    int candidato, n = leggi( A );
    int finito = 0;

    candidato = 0;
    while ( !finito && candidato < n+1 ) 
    {
	if(manca( A, n, candidato))
	{
	   printf("L'elemento mancante e': %d\n", i);
	   finito = 1;
	}
        candidato++;
   }
}
